#include "xhbasic.h"
#include "monitor.h"
#include "monitor.xpm"
#include "moni_broke.xpm"
#include "icon_ring.xpm"
#include "icon_doc.xpm"
#include "icon_shield.xpm"

#define NICONS 3

Pixmap mon = 0,monmask = 0;
Pixmap monbrk = 0,monbmask = 0;
Pixmap monicon[NICONS],miconmask[NICONS];
char **icondata[] = {
  icon_ring_xpm,
  icon_doc_xpm,
  icon_shield_xpm
};

Monitor::Monitor(XhedgehogWin *xw,float _x,float _y,int type) :
  ZoneObject(xw,_x,_y,mon,monmask,2,3) {
    if(mon == 0) {
      xw->LoadPixmap(monitor_xpm,&mon,&monmask);
      xw->LoadPixmap(moni_broke_xpm,&monbrk,&monbmask);
      for(int i=0;i<NICONS;i++) {
	xw->LoadPixmap(icondata[i],&(monicon[i]),&(miconmask[i]));
      }
    }
    ChangeSpriteShape(mon,monmask);
    ic = new MonitorIcon(this,type);
    ic->PlaceSpriteBehind(this);
    auto_animate = True; auto_hittest = True;
    brok = 0;
}

void Monitor::OnHitTest(Sprite *s) {
  Sonic *son;
  if(!brok) {
    if((son = dynamic_cast<Sonic *>(s)) != NULL) {
      if(son->GetFlag(ROLLFLAG)) {
	son->Bounce();
	brok = 1;
	ChangeSpriteShape(monbrk,monbmask);
	((XhedgehogWin *)host)->SoundSrvPlay(5);
	SetMaxFrames(1);
	ic->SetSpriteMotion(0,-8);
	ic->SetSonic(son);
      }
      else {
	if((son->YPos() + son->YSize() < y + (cy / 2)) &&
	   (son->YVel() > 0)) {
	  son->StandSurf(this);
	}
      }
    }
  }
}

MonitorIcon::MonitorIcon(Monitor *m,int t) : 
  ZoneObject((XhedgehogWin *)(m->Host()),m->XPos() + 7,m->YPos() + 9,
	     monicon[t],miconmask[t],1,1) {
  type = t;
  fy = y;
  son = NULL;
}
  
void MonitorIcon::MoveSprite(float newx,float newy) {
  ZoneObject::MoveSprite(newx,newy);
  if(y < fy) {
    vy += 0.5; if(vy >= 0) {
      Nuke();
      if(son) {
	switch(type) {
	case MRINGS:
	  son->IncreaseRingsByTen();
	  break;
	case MDOC:
	  son->EnemyHit();
	  break;
	case MSHIELD:
	  son->EnableShield();
	  break;
	}
      son = NULL;
      }
    }
  }
}
